<script type="text/javascript">
    function expand_graphs(e) {
        if (document.getElementById(`graphs-${e.target.id}`).style.display == "none") {
            e.target.children[0].style.transform = 'rotate(0deg)';
            document.getElementById(`graphs-${e.target.id}`).style.display = "flex";
        } else {
            e.target.children[0].style.transform = 'rotate(-90deg)';
            document.getElementById(`graphs-${e.target.id}`).style.display = "none";
        }
    }
</script>

<div class="title">
    <button class="expand" id="{{id}}" onclick="expand_graphs(event)">
        <i class="fa-solid fa-lg fa-chevron-down" style="pointer-events: none;"></i>
    </button>
    <h2>{{cpu_amount}} CPU - {{memory_amount}} MB Memory | {{len durations}} iterations</>
</div>

<div id="graphs-{{id}}" style="display: flex;">
    <div style="flex: 1;">
        <figure class="highcharts-figure">
            <div id="{{id}}-durations"></div>
        </figure>
    </div>
    <div style="flex: 1;">
        <figure class="highcharts-figure">
            <div id="{{id}}-ram"></div>
        </figure>
    </div>

    <div style="flex: 1;">
        <figure class="highcharts-figure">
            <div id="{{id}}-cpu"></div>
        </figure>
    </div>
</div>


<!-- CPU GRAPH -->
<script type="text/javascript">
Highcharts.chart('{{id}}-cpu', {
    title: {
        text: 'CPU usage'
    },

    yAxis: {
        title: {
            text: 'CPU usage'
        },

        labels: {
            formatter: function () {
                return this.pos + "%"
            }
        },
        plotLines: [{
            color: '#FF0000',
            width: 2,
            value: {{ cpu_amount }} * 100,
            dashStyle: "Dash",
            zIndex: 1,
            label: {
                text: "Limit {{ cpu_amount }} cores",
                style: {
                    color: '#FF0000',
                    fontWeight: 'bold'
                }
            }
        }],
        max: ({{ cpu_amount }} + 0.1 * {{ cpu_amount }}) * 100
    },
    xAxis: {
        title: {
            text: 'Normalized time'
        },
        labels: {
            formatter: function () {
                return this.pos + "s"
            }
        },
        events: {
            afterSetExtremes: function (event) {
                var xMin = event.min;
                var xMax = event.max;
                var ex = Highcharts.charts.find(c => c.renderTo.id == '{{id}}-ram').xAxis[0].getExtremes();

                if (ex.min != xMin || ex.max != xMax) {
                    Highcharts.charts.find(c => c.renderTo.id == '{{id}}-ram').xAxis[0].setExtremes(xMin, xMax, true, false);
                } 
            }
        }
    },

    tooltip: {
        formatter: function () {
            return this.y + " %"
        }
    },

    chart: {
        zoomType: 'x',
        type: 'spline'
    },

    legend: {
        enabled: false
    },

    plotOptions: {
        series: {
            label: {
                connectorAllowed: false
            },
            marker: {
                enabled: false,
            }
        }
    },

    series: [
        {
            name: 'Median',
            data: {{ format_y_values scale cpu_distribution.q2.values }},
            label: {
                enabled: false,
            },
        },
        {
            name: 'Dispersion',
            data: {{ format_dispersion_area scale cpu_distribution.q1.values cpu_distribution.q3.values }},
            type: 'areasplinerange',
            lineWidth: 0,
            linkedTo: ':previous',
            color: Highcharts.getOptions().colors[0],
            fillOpacity: 0.3,
            zIndex: 0,
            marker: {
                enabled: false
            },
            label: {
                enabled: false,
            },
        },
    ],
})
</script>

<!-- MEMORY GRAPH -->
<script type="text/javascript">
    Highcharts.chart('{{id}}-ram', {
        title: {
            text: 'Memory usage'
        },
        chart: {
            zoomType: 'x',
            type: 'spline'
        },

        yAxis: {
            title: {
                text: 'Memory usage',
                type: 'spline'
            },

            labels: {
                formatter: function () {
                    return Math.floor(this.pos / 1024 / 1024) + " MB"
                }
            },

            plotLines: [{
                color: '#FF0000',
                width: 2,
                value: {{ memory_amount }} * 1024 * 1024,
                dashStyle: "Dash",
                zIndex: 1,
                label: {
                    text: "Limit {{ memory_amount }} MB",
                    style: {
                        color: '#FF0000',
                        fontWeight: 'bold'
                    }
                }
            }],
            max: ({{ memory_amount }} + 0.1 * {{ memory_amount }}) * 1024 * 1024
        },

        xAxis: {
            title: {
                text: 'Normalized time'
            },
            labels: {
                formatter: function () {
                    return this.pos + "s"
                }
            },
            events: {
                afterSetExtremes: function (event) {
                    var xMin = event.min;
                    var xMax = event.max;
                    var ex = Highcharts.charts.find(c => c.renderTo.id == '{{id}}-cpu').xAxis[0].getExtremes();

                    if (ex.min != xMin || ex.max != xMax) {
                        Highcharts.charts.find(c => c.renderTo.id == '{{id}}-cpu').xAxis[0].setExtremes(xMin, xMax, true, false);
                    } 
                }
            }
        },

        tooltip: {
            formatter: function () {
                return Math.floor(this.y / 1024 / 1024) + " MB"
            }
        },

        legend: {
            enabled: false
        },

        plotOptions: {
            series: {
                label: {
                    connectorAllowed: false
                },
                marker: {
                    enabled: false,
                }
            }
        },

        series: [
            {
                name: 'Median',
                data: {{ format_y_values scale memory_distribution.q2.values }},
                label: {
                    enabled: false,
                },    
            },
            {
                name: 'Dispersion',
                data: {{ format_dispersion_area scale memory_distribution.q1.values memory_distribution.q3.values }},
                type: 'areasplinerange',
                lineWidth: 0,
                linkedTo: ':previous',
                color: Highcharts.getOptions().colors[0],
                fillOpacity: 0.3,
                zIndex: 0,
                marker: {
                    enabled: false
                },
                label: {
                    enabled: false,
                },
            },
        ],
    });
</script>

<!-- DURATION DISPERSION GRAPH -->
<script type="text/javascript">

    function median(numbers) {
        let sorted = Array.from(numbers).sort((a, b) => a - b);
        let middle = Math.floor(sorted.length / 2);

        if (sorted.length % 2 === 0) {
            return (sorted[middle - 1] + sorted[middle]) / 2;
        }

        return sorted[middle];
    }

    function silverman_bandwidth(data) {
        let factor = 4 / 3
        let exponent = 1 / 5
        let n = data.length

        let mean = data.reduce((a, b) => a + b) / n
        let sigma = Math.sqrt(data.map(x => Math.pow(x - mean, 2)).reduce((a, b) => a + b) / (n - 1))

        return sigma * Math.pow((factor / n), exponent)
    }

    function gauss_kde(xi, x, h) {
        return (1 / (Math.sqrt(2 * Math.PI))) * Math.exp(-.5 * Math.pow((xi - x) / h, 2));
    }

    (() => {

        let data_source = {{ durations }};

        if (data_source.length > 1) {
            let x_min = Math.min(...data_source);
            let x_max = Math.max(...data_source);
            let h = silverman_bandwidth(data_source);
            let N = data_source.length;


            let start = x_min - 5 * h
            let end = x_max + 5 * h;
            let scale = (end - start) / 100


            let xi_data = [];
            for (i = start; i < end; i += scale) {
                xi_data.push(i);
            }


            let data = xi_data.map(w => [w, data_source.map(x => gauss_kde(w, x, h)).reduce((a, b) => a + b) / N])


            Highcharts.chart("{{id}}-durations", {
                chart: {
                    type: "areaspline",
                    animation: true,
                    zoomType: 'x',
                },
                title: {
                    text: "Durations distribution"
                },

                xAxis: {
                    title: { text: "Duration" },
                    labels: {
                        format: "{value}s"
                    },
                    plotLines: [{
                        color: '#FF0000',
                        width: 2,
                        value: median(data_source),
                        dashStyle: "Dash",
                        zIndex: 1,
                        label: {
                            formatter: function () {
                                return Math.floor(median(data_source)) + "s"
                            },
                            style: {
                                color: '#FF0000',
                                fontWeight: 'bold',
                            },
                            rotation: 0
                        }
                    }],
                },

                yAxis: {
                    title: { text: "Density (a.u.)" }
                },

                plotOptions: {
                    series: {
                        marker: {
                            enabled: false
                        },
                        pointStart: xi_data[0],
                        areaspline: {
                            fillOpacity: 0.5
                        },
                        label: {
                            enabled: false
                        },
                    }
                },
                series: [
                    {
                        name: "KDE",
                        dashStyle: "solid",
                        lineWidth: 2,
                        data: data
                    }
                ],
                legend: {
                    enabled: false
                },
            });
        }
    })()
</script>